/*
 * (C) 1995-2001 Clemson University and Argonne National Laboratory.
 *
 * See COPYING in top-level directory.
 */


#ifndef META_H
#define META_H

/* includes for struct stat */
#include <sys/stat.h>
#include <unistd.h>

/* includes for sockaddr_in */
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

/* includes for umode_t */
#include <asm/types.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifdef NEED_UMODE_T_DEF
typedef unsigned short umode_t;
#endif

typedef struct dmeta dmeta, *dmeta_p;

struct dmeta {
	int64_t fs_ino; /* file system root directory inode # */
	uid_t dr_uid; /* directory owner uid # */
	gid_t dr_gid; /* directory owner gid # */
	umode_t dr_mode; /* directory mode # */
	u_int16_t port;
	char *host;
	char *rd_path;
	char *sd_path;
	char *fname;
};

typedef struct pvfs_filestat pvfs_filestat, *pvfs_filestat_p;
	
struct pvfs_filestat {
	int32_t base;
	int32_t pcount;
	int32_t ssize;
	int32_t soff;
	int32_t bsize;
};

typedef struct fmeta fmeta, *fmeta_p;

/* THIS IS STRICTLY HERE FOR SIZE CALCULATIONS IN BACKWARD COMPAT. CODE */
struct fmeta_1_5_0 {
	int64_t fs_ino; /* file system root directory inode # */
	struct stat u_stat;
	struct pvfs_filestat p_stat;
	struct sockaddr mgr;
};

/* this is the structure we're actually using */
struct fmeta {
	int64_t fs_ino; /* file system root directory inode # */
	struct stat u_stat;
	struct pvfs_filestat p_stat;
	int64_t fsize;
	struct sockaddr mgr;
};

/*
 * Local variables:
 *  c-indent-level: 3
 *  c-basic-offset: 3
 *  tab-width: 3
 * End:
 */

#ifdef __cplusplus
}
#endif

#endif

