/*
 * (C) 1995-2001 Clemson University and Argonne National Laboratory.
 *
 * See COPYING in top-level directory.
 */


#ifndef IOD_H
#define IOD_H

#include <config.h>
#include <minmax.h>
#include <req.h>
#include <alist.h>
#include <flist.h>
#include <jlist.h>
#include <pvfs_config.h>

#define STATNUM 5000

/* PROTOTYPES */
char *fname(ino_t f_ino);
int send_error(int status, int eno, int sock, iack_p);
ainfo_p ack_a_new(void);

int do_close_req(int sock, ireq_p r_p, iack_p a_p);
int do_open_req(int sock, ireq_p r_p, iack_p a_p);
int do_rw_req(int sock, ireq_p r_p, iack_p a_p);
int do_stat_req(int sock, ireq_p r_p, iack_p a_p);
int do_unlink_req(int sock, ireq_p r_p, iack_p a_p);
int do_shutdown_req(int sock, ireq_p r_p, iack_p a_p);
int do_gstart_req(int sock, ireq_p r_p, iack_p a_p);
int do_gadd_req(int sock, ireq_p r_p, iack_p a_p);
int do_instr_req(int sock, ireq_p r_p, iack_p a_p);
int do_ftruncate_req(int sock, ireq_p r_p, iack_p a_p);
int do_truncate_req(int sock, ireq_p r_p, iack_p a_p);
int do_fdatasync_req(int sock, ireq_p r_p, iack_p a_p);
int do_noop_req(int sock, ireq_p r_p, iack_p a_p);
int do_statfs_req(int sock, ireq_p r_p, iack_p a_p);
int update_fsize(finfo_p f_p);
int count_access(jinfo_p job_p, int *off_p);

void *do_signal(int);

/* SOCKINFO.C PROTOTYPES */
int is_active(int s);
int set_active(int s);
int clr_active(int s);

/* DEFINES */
/* mmap defines */
#define PAGENO(x) ((x) & (~(IOD_ACCESS_PAGE_SIZE - 1)))
#define PAGEOFF(x) ((x) & (IOD_ACCESS_PAGE_SIZE - 1))

#define IOD_MMAP_FLAGS MAP_FILE | MAP_SHARED | MAP_VARIABLE
#define IOD_MMAP_PROT PROT_READ

#ifndef MAP_VARIABLE
#define MAP_VARIABLE 0
#endif


#endif
