/*
 * (C) 1995-2001 Clemson University and Argonne National Laboratory.
 *
 * See COPYING in top-level directory.
 */


#ifndef  LIB_H
#define  LIB_H

#include "../config.h"

#ifdef LARGE_FILE_SUPPORT
/* we want to have the 64-bit functions available but not change the existing 
 * functions; _LARGEFILE64_SOURCE accomplishes this.
 */
#define _LARGEFILE64_SOURCE
#endif

#include <string.h>
#include <errno.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <sys/socket.h>
#include <syscall.h>
#include <fcntl.h>
#include <unistd.h>
#include <meta.h>
#include <req.h>
#include <desc.h>
#ifdef FS_H_IS_OK
#include <linux/fs.h> /* NR_OPEN declaration */
#endif
#include <debug.h>
#include <build_job.h>
#include <sockset.h>
#include <jlist.h>
#include <pvfs_config.h>


#undef PERROR
#ifdef DEBUG
#define PERROR(x) {perror(x); fflush(stderr);}
#else
#define PERROR(x);
#endif

/*PROTOTYPES*/
void *pvfs_exit(void);
int unix_lstat(const char *fn, struct stat *s_p);
int unix_stat(const char *fn, struct stat *s_p);
int unix_fstat(int fd, struct stat *s_p);
int pvfs_detect(const char *fn, char **, struct sockaddr **, int64_t *);

int send_mreq_saddr(struct sockaddr *saddr_p, mreq_p req_p,
	void *data_p, mack_p ack_p);
int send_mreq_dmeta(dmeta_p dir_p, mreq_p req_p, void *data_p,
	mack_p ack_p);

char *dmeta2fname(dmeta_p);

#endif
