/*
 * (C) 1995-2001 Clemson University and Argonne National Laboratory.
 *
 * See COPYING in top-level directory.
 */


static char md_mount_c[] = "$Header: /projects/cvsroot/pvfs/mgr/meta/md_mount.c,v 1.4 2001/01/30 23:32:21 pcarns Exp $";
/* This file contains the mount metadata file call for the PVFS*/
/* Assumes request has already been allocated */

#include <errno.h>
#include <stdio.h>
#include <sys/mount.h>
#ifdef FS_H_IS_OK
#include <linux/fs.h>
#endif
#include <sys/types.h>
#include <sys/file.h>
#include <linux/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <meta.h>
#include <req.h>

extern int errno;

int md_mount(mreq_p request)
{
	fmeta meta1;
	int size = sizeof(fmeta);
	int fd, i, flag;

	/* Check permission. Must be root */
	if (request->uid != 0) {
		perror("Mount permission denied.");
		errno = EPERM;
		return(-1);
	}	
	
	/* Read dot file */
	flag = O_RDONLY;
	if ((fd = open(request->req.mount.fsname, flag)) < 0) {
		perror("Dot File open.");
		return (-1);
	}	
	
	if ((i = read(fd, &meta1, size)) < 0) {
		perror("Dot file read");
		return(-1);
	}	
	
	/* Close dot file */
	if ((i = close(fd)) < 0) {
		perror("File close");
		return(-1);
	}

	
	/* Do acknowledge and return */
	return (0);
}
