/*
 * (C) 1995-2001 Clemson University and Argonne National Laboratory.
 *
 * See COPYING in top-level directory.
 */


/*
 * PVSTAT.C -	prints out information from metadata file
 *					Usage:  pvstat <filename>
 *
 */

#include <stdio.h>
#include <fcntl.h>
#include <pvfs.h>

int main (int argc, char *argv[])
{
	int i, fd, size;
	pvfs_filestat fstat;
	
	if (argc < 2) {
		fprintf(stderr, "usage: %s <filename>\n", argv[0]);
		return 1;
	}

	if ((fd = pvfs_open(argv[1], O_RDONLY)) < 0) {
		perror("pvfs_open");
		return 1;
	}

	if (pvfs_ioctl(fd, GETMETA, &fstat) < 0) {
		perror("pvfs_ioctl");
		return 1;
	}
	printf("%s: base = %d, pcount = %d, ssize = %d\n", argv[1], fstat.base,
	fstat.pcount, fstat.ssize);
	

	return 0;
}
